
#include <boost/mpl/map.hpp>
#include <boost/mpl/pair.hpp>
#include <boost/mpl/integral_c.hpp>
#include <boost/mpl/inherit_linearly.hpp>
#include <boost/mpl/inherit.hpp>
#include <boost/mpl/apply.hpp>
#include <boost/mpl/identity.hpp>

namespace mpl = boost::mpl;

enum MemberId
{
  YESNO
  , STH
  , OTHER
};

struct sth_t
{
    int i;
    long j;
};

template <class T> struct wrap
{
    T value;
};

template <class T> struct incomplete;

typedef mpl::map<
        mpl::pair<
                mpl::integral_c< MemberId, YESNO >
                , bool
                >
        , mpl::pair<
                  mpl::integral_c< MemberId, STH >
                  , sth_t const&
                  >
        , mpl::pair<
                  mpl::integral_c< MemberId, OTHER >
                  , char const*
                  >
        > id_to_member_type_t;

// incomplete<
        mpl::inherit_linearly<
                id_to_member_type_t
                , mpl::inherit<
                          mpl::_1
                          , wrap< mpl::first< mpl::_2 > >
                          >
                >::type
//         >
debug;


int main()
{
    return 0;
}
